#include <stdio.h>
#include <string.h>
#include <stdlib.h>

typedef struct{
	char eesnimi[30];
	char sugu;
	int paev, kuu, aasta;
}t_isik;

typedef struct{
	int n, max;
	t_isik *isikud;
	t_isik *tmp;
}t_arr;

#define SOURCEFILE "isikud.bin"
#define BUFLEN 1024

void salvesta(FILE *f, t_arr *a){
	for(int i = 0; i < a->n; i++)
		fprintf(f, "%s\t%c\t%02d.%02d.%d\n", a->isikud[i].eesnimi, a->isikud[i].sugu, a->isikud[i].paev, a->isikud[i].kuu, a->isikud[i].aasta);
}

//qsort jaoks võrdlusfunktsioon kuu ja päeva järgi
int vordle(const void *a, const void *b){
	t_isik *i1 = (t_isik *)a;
	t_isik *i2 = (t_isik *)b;
	if(i1->kuu == i2->kuu)
		return i1->paev - i2->paev; // kui sama kuu, siis võrdleme päevi
	else
		return i1->kuu - i2->kuu; // kui erinevad kuud, siis võrdleme kuid
}

//faili avamine, kui faili pole, siis väljutakse rakendusest
FILE *ava(const char *nimi, const char *tyyp){
	FILE *f = fopen(nimi, tyyp); 
	if(f == NULL){
		printf("Ei saanud avada faili %s\n", SOURCEFILE);
		exit(0); //väljume kogu rakendusest
	}
	return f;
}

//korjab teksti lõpust reavahetuse ära
void korrigeeri(char *s){
	int p = strlen(s);
	while(p > 0 && (s[p-1] == '\n' || s[p-1] == '\r'))
		s[--p] = '\0'; //vähendame p väärtust ja kirjutame teksti vastavale kohale tekstilõpetamise märgi
}

void loe_andmed2(t_arr *a, FILE *f){
	int max = 100; //esialgne oletus
	a->isikud = malloc(max * sizeof(*a->isikud)); //kasutame väljanime sizeof jaoks, siis ei pea üle kontrollima, mis tüüp oli
	if(a->isikud == NULL) // mälu eraldamine ei õnnestunud
		return; // midagi ei saanud lugeda
	a->max = max; //kui eraldamine õnnestus, siis muudame max väärtust
	a->n = fread(a->isikud, sizeof(*a->isikud), max, f);
	while(!feof(f)){ //esialgne oletus ei olnud õige, failis on rohkem andmeid
		max = max * 2; //suurendame mahtu 2 korda
		a->tmp = realloc(a->isikud, max * sizeof(*a->isikud)); //küsime mälu uue max suuruses
		if(a->tmp == NULL) //mälu eraldamine ei õnnestunud
			return; //midagi sai sisse loetud, sellega saab tegutseda
		a->isikud = a->tmp; //kirjutame massiivi viida üle
		a->n = a->n + fread(&a->isikud[a->n], sizeof(*a->isikud), max - a->max, f);
		//uus lugemine ütleb, mitu kirjet sai juurde loetud, seetõttu vaja liita (a->n = a->n + ...)
		//me pole enam massiivi alguses, seetõttu tuleb ette anda koht, kus eelmine lugemine lõppes (fread(&isikud[a->n])
		//meil on ruumi lugeda ainult niipalju kirjeid, mille võrra uus mäluruum on eelmisest suurem (max - a->max)
		a->max = max; //nüüd saame a->max üle kirjutada, eelmises operatsioonis oli vana väärtust veel vaja
	}
}

int main(void){
	char dstfile[BUFLEN];
	printf("Sisesta väljundfaili nimi: ");
	fgets(dstfile, BUFLEN, stdin); //loeme rea teksti.
	korrigeeri(dstfile);
	if(strcmp(SOURCEFILE, dstfile) == 0){ //samad failinimed
		printf("Sama failinimi, mis sisendil, kas kirjutame üle? (j/e): ");
		char buf[BUFLEN];
		scanf("%s", buf);
		if(buf[0] == 'e' || buf[0] == 'E'){
			return 0;
		}
	}
	FILE *out = ava(dstfile, "w"); //kirjutamiseks
	FILE *f = ava(SOURCEFILE, "rb"); //lugemiseks
	t_arr andmed = {0, 0, NULL, NULL}; //algväärtustame
	loe_andmed2(&andmed, f); //edastame alamprogrammile viida.
	printf("n/c : %d/%d\n", andmed.n, andmed.max);
	fclose(f); // seda faili pole enam vaja lahti hoida
	if(andmed.n == 0)
		return 0; // pole midagi sortida
	qsort(andmed.isikud, andmed.n, sizeof(t_isik), vordle); //sorteerime massiivi kasutades enda loodud võrdlusfunktsiooni
	salvesta(out, &andmed);
	fclose(out);
	free(andmed.isikud); //vabastame mälu	
	return 0;
}

